unit uDemoDrawingBounds;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  uMASelectionManager, uMAClasses, uMASelectionCreator, uMASelectionControl,
  StdCtrls, uMARoutines;

type
  TfrmDemoDrawingBounds = class(TForm)
    SelectionControl1: TSelectionControl;
    SelectionCreator1: TSelectionCreator;
    SelectionManager1: TSelectionManager;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmDemoDrawingBounds: TfrmDemoDrawingBounds;

implementation

{$R *.DFM}

var
 Temp : HRGN;


function CreateDrawingBounds(Rect: TRect):HRGN;
var
  Rect2 : TRect;
  Hole : HRGN;
begin
  Rect2 := Rect;
  //Create Outer Ellipse
  Result := CreateEllipticRgn(Rect.Left,Rect.Top,Rect.Right,Rect.Bottom);
  //Shrink and subtract
  InflateRect(Rect2,-60,-40);
  Hole := CreateEllipticRgn(Rect2.Left,Rect2.Top,Rect2.Right,Rect2.Bottom);
  CombineRgn(Result,Result,Hole, RGN_XOR);
end;

procedure TfrmDemoDrawingBounds.FormCreate(Sender: TObject);
begin
  SelectionControl1.WinControl := Self;
  SelectionControl1.DrawingBounds.Region := CreateDrawingBounds(ClientRect);
  SelectionControl1.RunEngine := True;
  SelectionManager1.LockToCursor := True;
end;

procedure TfrmDemoDrawingBounds.FormPaint(Sender: TObject);
begin
  ViewRegion(Canvas.Handle,SelectionCreator1.DrawingBounds, clRed);
end;

end.
